function SliceOut=fun_InterpKernel(SliceIn,LFDimOut,LFDimIn,blurKernel)
[H,W,C,~]=size(SliceIn);
upScale=fix(LFDimOut/LFDimIn)+1;

% "Blur" step
SliceBlured=zeros(H,W,C,LFDimIn);
sizeKernel=size(blurKernel,2);
for i=1:LFDimIn
    im=SliceIn(:,:,:,i);
    if sizeKernel>1
        im=imfilter(im,blurKernel,'conv','circular');
    end
    SliceBlured(:,:,:,i)=im;
end

% "Restoration" step
SliceOut=zeros(H,LFDimOut,W,C);
parfor i=1:H
    EPIIn=SliceBlured(i,:,:,:);
    EPIIn=permute(uint8(EPIIn),[4,2,3,1]);
    
%---------Select a restoration kernel----------
    % SCN
%     EPIOut=fun_SRSCN(EPIIn,upScale);
    % Sparse coding
%     EPIOut=fun_SRSC(EPIIn,upScale);
    % SRCNN
%     EPIOut=fun_SRCNN(EPIIn,upScale);
    % VDSR
    EPIOut=fun_VDSR(EPIIn,0,upScale);
%----------------------------------------------
    EPIOut=imresize(EPIOut,[LFDimOut,W],'bicubic');
    SliceOut(i,:,:,:)=uint8(EPIOut);
end
SliceOut=permute(SliceOut,[1,3,4,2]);